﻿@using LoyaltyPointEngine.Model.Object.Member

@{
    string search = ViewBag.Search,
        orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        paginationShowRange = 5,
        totalRow = ViewBag.TotalRow;

    bool isSPG = ViewBag.IsSpg != null ? (bool)ViewBag.IsSpg : false;
}
@model List<MemberGridModel>

@*@Html.Grid(Model).Named("AllMember").Columns(columns =>
     {
         columns.Add(x => x.Type)
          .Titled("Type")
          .Encoded(false)
          .Sanitized(false)
          .Sortable(true)
          .RenderValueAs(x => x.Type);

         columns.Add(x => x.Gender)
             .Titled("Gender")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => x.Gender);

         columns.Add(x => x.FirstName)
             .Titled("FirstName")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => x.FirstName);

         columns.Add(x => x.LastName)
            .Titled("LastName")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.LastName);

         columns.Add(x => x.Email)
            .Titled("Email")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.Email);

         columns.Add(x => x.Phone)
            .Titled("Phone")
            .Encoded(false)
            .Sanitized(false)
            .Sortable(true)
            .RenderValueAs(x => x.Phone);

         columns.Add(x => x.IsBlacklist)
       .Titled("IsBlacklist")
       .Encoded(false)
       .Sanitized(false)
       .Sortable(true)
       .RenderValueAs(x => x.IsBlacklist.ToString());



         columns.Add(x => x.Point)
         .Titled("Point")
         .Encoded(false)
         .Sanitized(false)
         .Sortable(true)
         .RenderValueAs(x => x.Point.HasValue ? x.Point.Value.ToString() : " - ");


         columns.Add(x => x.CreatedDate)
             .Titled("Created Date")
             .Encoded(false)
             .Sanitized(false)
             .Sortable(true)
             .RenderValueAs(x => x.CreatedDate.HasValue ? x.CreatedDate.Value.ToString("dd-MM-yyyy") : string.Empty);

         columns.Add()
             .Encoded(false)
             .Sanitized(false)

             .Css("cell-center")
         .RenderValueAs(x => string.Format("<a href=\"{0}\" class=\"btn btn-xs btn-info\">Edit</a>",
             Url.Action(MVC.Member.Edit(x.ID))));



         columns.Add()
             .Encoded(false)
             .Sanitized(false)
             .Css("cell-center")
         .RenderValueAs(x => string.Format("<a href=\"{0}\" class=\"btn btn-xs btn-info\">History</a>",
             Url.Action(MVC.Member.History(x.ID))));

         //columns.Add()
         //    .Encoded(false)
         //    .Sanitized(false)
         //    .SetWidth(50)
         //    .Css("cell-center")
         //    .RenderValueAs(x => string.Format("<a href=\"{0}\" data-link=\"{1}\" data-name=\"{2}\" class=\"btn btn-xs btn-danger confirmModal\">Delete</a>", "#", Url.Action(MVC.Member.Delete(x.ID)), x.FirstName));

     })
    .Sortable()
    .WithPaging(5)*@

<div class="widget-header">
    <h4><i class="icon-reorder"></i>All Member</h4>
</div>
<div class="right-title">
    <form name="gridForm">
        <input type="text" id="txtSearch" name="txtSearch" value="@search" class="form-control box-search" placeholder="Search for...">
        <input type="hidden" id="rawDataUrl" name="rawDataUrl" value="@GenerateUrl("@search@", orderColumn, orderColumn, orderDirection, 0)" />
    </form>
</div>
<div id="grid-wrapper" class="widget-content">
    <table class="table table-striped grid-table">
        <thead>
            <tr>
                @*<th class="grid-header" title="Type"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Type", orderColumn, orderDirection, 0)">Type</a></div></th>*@
                <th class="grid-header" title="Gender"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Gender", orderColumn, orderDirection, 0)">Gender</a></div></th>
                <th class="grid-header" title="FirstName"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "FirstName", orderColumn, orderDirection, 0)">FirstName</a></div></th>
                <th class="grid-header" title="LastName"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "LastName", orderColumn, orderDirection, 0)">LastName</a></div></th>
                <th class="grid-header" title="Email"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Email", orderColumn, orderDirection, 0)">Email</a></div></th>
                <th class="grid-header" title="Phone"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Phone", orderColumn, orderDirection, 0)">Phone</a></div></th>
                <th class="grid-header" title="IsBlacklist"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "IsBlacklist", orderColumn, orderDirection, 0)">IsBlacklist</a></div></th>
                <th class="grid-header" title="Point"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "Point", orderColumn, orderDirection, 0)">Point</a></div></th>
                <th class="grid-header" title="Created Date"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "CreatedDate", orderColumn, orderDirection, 0)">Created Date</a></div></th>
                <th class="grid-header" title="EventCode"><div class="grid-header-title">Event Code</div></th>
                <th class="grid-header" title="Channel"><div class="grid-header-title">Channel</div></th>
                <th class="grid-header" title="IsActive"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "IsActive", orderColumn, orderDirection, 0)">IsActive</a></div></th>
                <th class="grid-header" title="Active Date"><div class="grid-header-title"><a data-url="@GenerateUrl(search, "ActiveDate", orderColumn, orderDirection, 0)">Active Date</a></div></th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
            </tr>
        </thead>
        <tbody>
            @foreach (MemberGridModel member in Model)
            {
                <tr class="grid-row ">
                    @*<td class="grid-cell" data-name="Type">@member.Type</td>*@
                    <td class="grid-cell" data-name="Gender">@member.Gender</td>
                    <td class="grid-cell" data-name="FirstName">@member.FirstName</td>
                    <td class="grid-cell" data-name="LastName">@member.LastName</td>
                    <td class="grid-cell" data-name="Email">@member.Email</td>
                    <td class="grid-cell" data-name="Phone">@member.Phone</td>
                    <td class="grid-cell" data-name="IsBlacklist">@member.IsBlacklist</td>
                    <td class="grid-cell" data-name="Point">@member.Point</td>
                    <td class="grid-cell" data-name="CreatedDate">@(member.CreatedDate.HasValue ? member.CreatedDate.Value.ToString("dd-MM-yyyy") : "")</td>
                    <td class="grid-cell" data-name="EventCode">@member.EventCode</td>
                    <td class="grid-cell" data-name="Channel">@member.Channel</td>
                    <td class="grid-cell" data-name="IsActive">@member.IsActive</td>
                    <td class="grid-cell" data-name="ActiveDate">@(member.ActiveDate.HasValue ? member.ActiveDate.Value.ToString("dd-MM-yyyy") : "")</td>
                    @if (!isSPG)
                    {
                        <td class="grid-cell cell-center" data-name=""><a href="@Url.Action(MVC.Member.Edit(member.ID))" class="btn btn-xs btn-info">Edit</a></td>
                        <td class="grid-cell cell-center" data-name=""><a onclick="confirmDelete('Are you sure want to remove @member.Email from member?', '@(Url.Action(MVC.Member.Delete(member.ID)))')" class="btn btn-xs btn-danger">Delete</a></td>
                        <td class="grid-cell cell-center" data-name=""><a href="@Url.Action(MVC.Member.History(member.ID))" class="btn btn-xs btn-info">History</a></td>
                    }
                </tr>
            }
        </tbody>
    </table>
    @if (totalPage > 1)
    {
        int startPage = currentPage - paginationShowRange > 1 ? currentPage - paginationShowRange : 1,
            endPage = currentPage + paginationShowRange < totalPage ? currentPage + paginationShowRange : totalPage;

        <div class="grid-footer">

            <div class="grid-pager">
                <ul class="pagination">
                    <li>
                        <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, currentPage <= 1 ? currentPage: currentPage -1, true)" class="grid-prev-page" title="Previous Page" style="">
                            <span class="glyphicon glyphicon-step-backward"></span>
                        </a>
                    </li>
                    @for (var _page = startPage; _page <= endPage; _page++)
                    {
                        @*<li><a href="#" class="grid-pageSetLink prev" style="display: none;" data-pageset="1" data-partitionsize="5">...</a></li>*@
                        <li class="@(currentPage == _page ? "active": "")">
                            <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, _page, true)" class="grid-page-link">
                                @_page
                            </a>
                        </li>
                    }
                    <li>
                        <a class="grid-page-link">
                            @totalPage
                        </a>
                    </li>
                    <li>
                        <a data-url="@GenerateUrl(search, orderColumn, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1, true)" title="Next Page" class="grid-next-page">
                            <span class="glyphicon glyphicon-step-forward"></span>
                        </a>
                    </li>
                </ul>
            </div>
            <div>
                Total Row : @totalRow
            </div>
        </div>
    }
</div>

@functions {
    public string GetOrderDirectionByColumn(string currentCol, string currentDirection, string targetColumn, bool isPaging)
    {
        if (isPaging) return currentDirection;

        if (currentCol.ToLower() == targetColumn.ToLower())
        {
            if (currentDirection.ToLower() == "asc") return "desc";
            else return "asc";
        }
        return currentDirection;
    }

    public string GenerateUrl(string search, string targetColumn, string orderColumn, string orderDirection, int? page, bool isPaging = false)
    {
        return Url.Action(MVC.Member.GridGetAllMemberPager(search, targetColumn, GetOrderDirectionByColumn(orderColumn, orderDirection, targetColumn, isPaging), page));
    }
}